import { IWorkerActionType } from './actions';
import { WorkerDBServerCore } from '../core';
import * as hyperid from 'hyperid';
export interface IWorkerDBWorker {
    onerror: ((this: any, ev: any) => any) | null;
    onmessage: ((this: any, ev: any) => any) | null;
    postMessage: (data: any) => void;
    terminate: Function;
}
export interface IWorkerDBMock {
    send: (data: any) => void;
    listen: ((data: any) => void);
}
export interface IWorkerDBSyncing {
}
export interface IWorkerDBError {
}
export interface IWorkerDBOptions {
    onClosed?: () => void;
    onReady?: (value: WorkerDBClientRX) => void;
    onError?: (value: Error) => void;
    onSyncing?: (value: boolean) => void;
}
export interface IWorkerDBCollection<T = any> {
    findOne: (value?: any) => T;
    find: (value?: any) => [T];
    remove: (id: string) => void;
    insert: (value: T) => Promise<T>;
    upsert: (value: T) => Promise<T>;
}
export interface IWorkerDBCallback {
    (error: Error | null, value?: any): any;
}
export declare class WorkerDBClientRX extends WorkerDBServerCore {
    options: IWorkerDBOptions;
    subscriptions: {};
    terminateIn5: Number;
    isReady: boolean;
    isClosed: boolean;
    generateID: hyperid.Instance;
    constructor(options?: IWorkerDBOptions);
    query: (collection: string | null, type: string, value: any, cb?: IWorkerDBCallback | undefined) => (() => void) | Promise<{}>;
    exec: (data: {
        type: IWorkerActionType;
        ref: string;
        value: any;
        error: any;
    }) => void;
    c: (name: string) => IWorkerDBCollection<any>;
    collection: (name: string) => IWorkerDBCollection<any>;
    init: (value?: any) => Promise<this>;
    reset: () => Promise<this>;
    cancelTermination: boolean;
    terminated: boolean;
    close: () => Promise<{}>;
}
//# sourceMappingURL=client.d.ts.map