"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createElectronServer(server, window) {
    var ipcMain = require('electron').ipcMain;
    server.addListener(function (data) { return window.webContents.send('workerdb', data); });
    ipcMain.on('workerdb', function (event, data) {
        server.exec(data);
    });
    return server;
}
exports.createElectronServer = createElectronServer;
function createElectronClient(client) {
    var ipcRenderer = require('electron').ipcRenderer;
    client.addListener(function (data) { return ipcRenderer.send('workerdb', data); });
    ipcRenderer.on('workerdb', function (event, data) {
        client.exec(data);
    });
    return client;
}
exports.createElectronClient = createElectronClient;
//# sourceMappingURL=electron.js.map