"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("../core");
var hyperid = require("hyperid");
var WorkerDBClientRX = /** @class */ (function (_super) {
    __extends(WorkerDBClientRX, _super);
    function WorkerDBClientRX(options) {
        var _this = _super.call(this) || this;
        _this.options = {};
        _this.subscriptions = {};
        _this.isReady = false;
        _this.isClosed = false;
        _this.generateID = hyperid();
        // Send a query to database, either callbase (watch) or promise (once)
        _this.query = function (collection, type, value, cb) {
            var ref = _this.generateID();
            var listener = function (callback) { return function (data) {
                if (data && data.live === false) {
                    delete _this.subscriptions[data.ref];
                }
                if (data && data.error) {
                    return callback(data.error);
                }
                return callback(null, data.value);
            }; };
            var send = function () {
                return _this.listener({
                    ref: ref,
                    collection: collection,
                    type: type,
                    live: !!cb,
                    value: value
                });
            };
            if (cb) {
                _this.subscriptions[ref] = listener(cb);
                send();
                return function () {
                    return _this.listener({
                        ref: ref,
                        type: 'stop'
                    });
                };
            }
            return new Promise(function (yay, nay) {
                _this.subscriptions[ref] = listener(function (err, val) {
                    return err ? nay(err) : yay(val);
                });
                send();
            });
        };
        // Listen to messages from webworker
        _this.exec = function (data) {
            if (_this.subscriptions[data.ref]) {
                _this.subscriptions[data.ref](data);
            }
            if (data.type === 'syncing' && _this.options.onSyncing) {
                _this.options.onSyncing(data.value);
            }
            else if (data.type === 'error' && _this.options.onError) {
                _this.options.onError(data.error);
            }
            else if (data.type === 'ready' && !_this.isReady) {
                _this.isReady = true;
                if (_this.options.onReady) {
                    _this.options.onReady(_this);
                }
            }
            else if (data.type === 'close') {
                _this.isClosed = true;
                _this.terminated = true;
                if (_this.options.onClosed) {
                    _this.options.onClosed();
                }
            }
        };
        _this.c = function (name) {
            return _this.collection(name);
        };
        _this.collection = function (name) {
            var query = _this.query;
            var handler = {
                get: function (obj, propName) {
                    return function (dd, cb) {
                        return query(name, propName, dd, cb);
                    };
                }
            };
            return new Proxy({ method: true }, handler);
        };
        _this.init = function (value) {
            if (value === void 0) { value = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.query('', 'init', value)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/, this];
                    }
                });
            });
        };
        _this.reset = function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.query('', 'reset', {})];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, this];
                }
            });
        }); };
        _this.cancelTermination = false;
        _this.terminated = false;
        // Close Database
        _this.close = function () {
            _this.cancelTermination = false;
            // Delay termination to allow cancelation while hot reloading
            return new Promise(function (yay) {
                setTimeout(function () { return __awaiter(_this, void 0, void 0, function () {
                    var e_1;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                if (!!this.cancelTermination) return [3 /*break*/, 5];
                                _a.label = 1;
                            case 1:
                                _a.trys.push([1, 3, , 4]);
                                return [4 /*yield*/, this.query('', 'close', {})];
                            case 2:
                                _a.sent();
                                return [3 /*break*/, 4];
                            case 3:
                                e_1 = _a.sent();
                                return [3 /*break*/, 4];
                            case 4:
                                // this.worker.terminate();
                                this.cancelTermination = false;
                                _a.label = 5;
                            case 5:
                                yay(this);
                                return [2 /*return*/];
                        }
                    });
                }); }, 100);
            });
        };
        _this.options = options || _this.options;
        return _this;
    }
    return WorkerDBClientRX;
}(core_1.WorkerDBServerCore));
exports.WorkerDBClientRX = WorkerDBClientRX;
//# sourceMappingURL=client.js.map