"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function createWorker(server, webworker) {
    if (webworker === void 0) { webworker = self; }
    var listener = function (body) { return webworker.postMessage(body); };
    server.addListener(listener);
    webworker.onmessage = function (event) { return server.exec(event.data); };
    webworker.onerror = function (event) {
        console.error(event);
    };
    return server;
}
exports.createWorker = createWorker;
//# sourceMappingURL=worker.js.map